#INCLUDE Foxpro.H


* PARAMETERS pcPar01, pcPar02, pcPar03, pcPar04, pcPar05, pcPar06, pcPar07, pcPar08, pcPar09


*       MUSTER
*
cRelease="Rel. 1.0.2 21.02.2003"              && release of program
cProgram="Mail2Dbf"

IF .not.FirstInstance(cProgram)
   MessageBox("Program is already running"+CHR(13)+"cancel...",0+16,cProgram)
   QUIT
ENDIF

DO FORM waitwind NAME frmWait WITH "<"+cProgram+">"+CHR(13)+"Application is loading..."

store [] to cCfgFile, cIniFile, cLogFile, cHelpFile, cDataDir, cDSN, cPassword, cLogin

Settings("Save")
SetEnvironment(cProgram)		&& std files, SETtings
ON SHUTDOWN DO ProgramShutdown


* ON ERROR
* _SCREEN.Visible=.T.

cINIfile=iif( file(cINIfile), FullPath(cINIfile), ForcePath(cINIfile, JustPath(sys(16, 0))) )

Logging(cProgram+" START "+cRelease)
Logging(cProgram+" Used Params - Common/INIFILE: "+FullPath(cINIfile)+iif(file(cINIfile), " ", " not ")+"present")
Logging(cProgram+" Used Params - Common/CFGFILE: "+FullPath(cCfgfile)+iif(file(cCFGfile), " ", " not ")+"present")
Logging(cProgram+" Used Params - Common/HELPFILE: "+FullPath(cHelpfile)+iif(file(cHELPfile), " ", " not ")+"present")


*cParam01=GetIniPar(cIniFile, "param01", "Common")
*Logging(cProgram+" Used Params - Common/param01: "+cParam01)

*cParam02=GetIniPar(cIniFile, "param02", "Mail2Dbf", [Param02])			&& char param
*Logging(cProgram+" Used Params - Mail2Dbf/param02: "+cParam02)

*lParam03=InList( Upper(GetIniPar(cIniFile, "param03", "Mail2Dbf", [NO])),						;
*					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& logical param
*Logging(cProgram+" Used Params - Mail2Dbf/param03: "+iif(lParam03, "YES", "NO"))

*nParam04=val(GetIniPar(cIniFile, "param04", "Mail2Dbf", [0]))			&& num param
*Logging(cProgram+" Used Params - Mail2Dbf/param04: "+Transform(nParam04))

lMinimizeToSysTray=InList( Upper(GetIniPar(cIniFile, "MinimizeToSysTray", "Mail2Dbf", [YES])),						;
					   ".T.", "T", "1", "YES", "Y", "TRUE", "JA", "J", "ANO", "A", "ON" )		&& logical param
Logging(cProgram+" Used Params - Mail2Dbf/MinimizeToSysTray: "+iif(lMinimizeToSysTray, "YES", "NO"))


* Kontrola pouzitych OCX a DLL
cRegKey=[TRAYICO.TrayIcoCtrl.1]
cOCXfile=FullPath([Trayico.ocx])
IF .not.myRegisterDLL(cRegKey, cOCXfile)
	Logging(cProgram+[ Registering ]+cOCXfile+ [ failed])
	MessageBox([ Registering ]+cOCXfile+[ failed], 16, cProgram)
	RETURN 1
Else
	Logging(cProgram+[ Registering ]+cOCXfile+[ O.K.])
ENDIF


gnLeft=0					&& saved Variables
gnTop=0
gnHeight=470
gnWidth=630
glRunExcel=.T.
store [] to gcInputFile, gcInputDir, gcOutputFile

If file(cCfgFile)                       && config file (all g* variables saved)
  restore from (cCfgFile) additive
endif
save all like g* to (cCfgFile)

nHandle=-1		&& ODBC handle
dStichTag=date()

gnHelpContextId=41
lMainCyklus=.T.


frmWait.Release()
DO WHILE lMainCyklus
  lMainCyklus=.F.

  DO FORM Mail2Dbf NAME frmMail2Dbf
  READ EVENTS

ENDDO

QUIT
RETURN 0

*****                   UP                      *****


*****

FUNCTION ProgramShutdown()
ON SHUTDOWN
clear events
Logging(cProgram+" END")
sys(1104)		&& zapis buffery
Flush
GetNewTmp([Delete])
save all like g* to (cCfgFile)
Iif(nHandle > 0, SQLdisconnect(nHandle), .F.)
Settings("Restore")
quit
RETURN .T.



*****

FUNCTION Durchfuehren(cP)
private all like x*
* DO FORM ProcessingWIndow NAME frmProcess WITH "<Mail2Dbf>"+CHR(13)+"Processing...", 1
Logging(cProgram+" Exporting InBox into: "+gcOutputFile)
xcSel=Alias()
xcTmpDbf=GetNewTmp()+[.dbf]            && Unique TMP filename
xcTmpXls=GetNewTmp()+[.xls]
WITH frmMail2Dbf

	xnEmailCount=.Emajl.ReadMail()
	Logging(cProgram+" MailItems in Inbox found: "+Transform(xnEmailCount))
	IF xnEmailCount > 0
		.ProgressBar.Visible=.T.
		create table (xcTmpDbf)	(		;
												SENDER	C(250),	SUBJECT C(250), BODY M,			;
												RECIPADDR C(250), RECIPNAME C(250),		;
												CCADDR C(250), CCNAME C(250),					;
												MSGTIME C(16), ATTACH M, ATTCOUNT N(3))
		use
		use (xcTmpDbf) alias TMPDBF exclusive
		
		FOR xnEmailIndex=1 to xnEmailCount
			xnProgressValue=(xnEmailIndex * 100 / xnEmailCount)
			.ProgressBar.Value=xnProgressValue
			append blank
			xoMessage=.Emajl.GetMessageInfo(xnEmailIndex)		&& current message
			.Emajl.GetMessage(xnEmailIndex)			&& posit message
	    xcAttach=[]
	    xnAttachCount=.Emajl.GetAttachmentCount(xnEmailIndex)	&& funguje
	    for xnAttachIndex=1 to  xnAttachCount
	      xcAttach=xcAttach+iif(empty(xcAttach), [], [; ])+.Emajl.GetAttachmentFile(xnAttachIndex)
	    endfor
			replace		SENDER		with		xoMessage.Sender,					;
								SUBJECT		with		xoMessage.Subject,				;
								BODY			with		xoMessage.BodyText,				;
								RECIPADDR	with		xoMessage.RecipientAddr,	;
								RECIPNAME	with		xoMessage.RecipientName,	;
								CCADDR		with		xoMessage.RecipientAddrCC,;
								CCNAME		with		xoMessage.RecipientNameCC,;
								MSGTIME		with		xoMessage.MessageTime,		;
								ATTACH		with		xcAttach,									;
								ATTCOUNT	with		xnAttachCount								
		ENDFOR
		.ProgressBar.Visible=.F.
		myBrowse(.T., [], [width 25])

		copy to (gcOutputFile) type Fox2x
		IF glRunExcel
*			copy to (xcTmpXls) type XL5
			Copy2Xls(xcTmpXls)
*			Dbf2Xls(xcTmpXls, [Inbox])
		  loExcel=NewObject("Excel.Application")
		  WITH loExcel
		  .workbooks.open(xcTmpXls)
		  xnLastCol=.ActiveCell.SpecialCells(11).Column		&& 1. radek Bold a zluty
		  .Range(.Cells(1,1), .Cells(1,xnLastCol)).Select()
		  .Selection.Font.Bold=.T.
		  .Selection.Interior.ColorIndex = 6
		  .Cells.Select()					&& upravit sirku sloupcu
		  .Selection.Autofilter()
		  .Selection.Columns.AutoFit()
		  .Cells(2,1).Select()
		  .ActiveWindow.SplitColumn=0
		  .ActiveWindow.SplitRow=1
		  .ActiveWindow.FreezePanes=.T.
		  .visible=.T.
		  ENDWITH
		ENDIF
		use
	ELSE		&& 0 nebo chyba
		IF xnEMailCount < 0
			Logging(cProgram+" Link to MAPIclient failed")
		ENDIF
	ENDIF
ENDWITH

select (iif(empty(xcSel), 0, (xcSel)) )
ClearFRO("FRO")
RETURN .T.

***** never run

myEscape()
ErrTrap()

*****

